package com.juxin.client.websocket;


import com.juxin.client.websocket.constant.GfConstants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import javax.websocket.*;
import java.io.IOException;

@ClientEndpoint
@Component
public class WebSocketClient {
    private volatile Session userSession = null;

    public Session getUserSession() {
        return userSession;
    }

    public void setUserSession(Session userSession) {
        this.userSession = userSession;
    }

    @OnOpen
    public void onOpen(Session userSession) throws IOException {
        System.out.println("Opening websocket");
        this.userSession = userSession;
        System.out.println("Connected to endpoint: " + userSession.getBasicRemote());
    }

    @OnClose
    public void onClose(Session userSession, CloseReason reason) {
        System.out.println("Closing websocket");
        this.userSession = null;
        GfConstants.FIND_FLAG = true;
        GfConstants.FIND_RESULT_FLAG = true;
        try {
            // 发送消息
            sendMessage("{ \"infoType\": \"getResultQueueJob\", \"postType\": \"python\", \"methodType\": \"getResultQueueJob\" }");
            GfConstants.FIND_RESULT_FLAG = false;
            // 保持连接一段时间
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @OnMessage
    public void onMessage(String message) {

        System.out.println("Received message: " + message);
        if(userSession == null) {
            return;
        }
        try {
            SpringUtil.getBean(FindTask.class).dealTask(message);
        } finally {
            GfConstants.FIND_FLAG = true;
            GfConstants.FIND_RESULT_FLAG = true;
        }

    }

    public void sendMessage(String message) throws InterruptedException {
        Thread.sleep(200);
        synchronized (WebSocketClient.class) {
            this.userSession.getAsyncRemote().sendText(message);
        }
        System.out.println("send message: " + message);
    }
}
