package com.juxin.client.websocket.enums;

public enum WebsocketTypeEnum {

    ONLINE_MSG("online","websocket上线消息"),
    CONNECT_MSG("connect","websocket连接消息"),
    HEART_MSG("heart","websocket心跳消息"),
    COMMIT_MSG("commit", "提交查询流程"),
    OVER_MSG("over", "结束查询流程"),
    SEARCH_LIST_MSG("list", "查询列表流程"),
    RESULT_LIST_MSG("result", "结果流程"),
    LICENSE_MSG("license", "许可"),
    CLOSE_PYTHON("closePython","关闭python服务"),
    ALARM_DATA("alarmData","预警数据"),
    STOP_PAY("stopPay","预警止付"),
    STOP_PAY_UPDATE("stopPayUpdate","预警止付更新"),
    LOG_MSG("logMsg", "日志传输"),
    GET_QUEUE_JOB("getQueueJob","获取执行队列任务"),
    GET_RESULT_QUEUE_JOB("getResultQueueJob","获取回捞结果任务")
    ;
    /**
     * websocket 识别标识
     */
    private String typeName;
    /**
     * 对应具体业务方法名称
     */
    private String methodName;

    WebsocketTypeEnum(String typeName, String methodName) {
        this.typeName = typeName;
        this.methodName = methodName;
    }

    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    public String getMethodName() {
        return methodName;
    }

    public void setMethodName(String methodName) {
        this.methodName = methodName;
    }

    public static WebsocketTypeEnum getEnumByType(String typeName) {
        for (WebsocketTypeEnum typeEnum : WebsocketTypeEnum.values()) {
            if (typeEnum.getTypeName().equals(typeName)) {
                return typeEnum;
            }
        }
        return null;
    }
}
